#include "bits/stdc++.h"
#include "stub.h"

using namespace std;

int koduj(int a, int b, int n) {
  return a*n+b;
}

int solve(int n) {
  set <int> przekatne_od_0;
  for (int i=1; i<n-1; i++) {
    if (query(0, i)) {
      przekatne_od_0.insert(i);
    }
  }
  // Jeśli istnieje przekątna dzieląca wielokąt dokładnie na pół,
  // to musi to być odpowiedź, ponieważ każda inna przekątna będzie
  // miała większą odległość w lewo lub w prawo (ponieważ pozostałe
  // przekątne znajdą się albo po lewej, albo po prawej stronie
  // wielokąta podzielonego tą przekątną).
  if (przekatne_od_0.find(n/2) != przekatne_od_0.end()) {
    return koduj(0, n/2, n);
  }
  // W przeciwnym razie próbujemy znaleźć najbliższe punkty po przeciwnej
  // stronie od 0, które mają przekątne idące zarówno w lewo, jak i w prawo
  // od tego wielokąta.
  int lewy = 1, prawy = n-1;
  for (int i=2; i<n/2; i++) {
    if (przekatne_od_0.find(i) != przekatne_od_0.end()) lewy = i;
  }
  for (int i=n-2; i>=(n+1)/2; i--) {
    if (przekatne_od_0.find(i) != przekatne_od_0.end()) prawy = i;
  }
  // Ta przekątna musi istnieć, ponieważ nie mamy przekątnej łączącej 0
  // z punktem po przeciwnej stronie od 0, a to jest pełna triangulacja.
  // Zatem to jest nasza odpowiedź.
  return koduj(lewy, prawy, n);
}
